diff --git a/client/suse/compat-suse.c b/client/suse/compat-suse.c
index 85b01df12..d2fdd9a49 100644
--- a/client/suse/compat-suse.c
+++ b/client/suse/compat-suse.c
@@ -28,20 +28,6 @@
 #include "config.h"
 #endif
 
-#include <stdio.h>
-#include <string.h>
-#include <stdlib.h>
-#include <limits.h>
-#include <ctype.h>
-#include <errno.h>
-#include <net/if_arp.h>
-#include <net/ethernet.h>
-#include <netlink/netlink.h>
-#include <sys/types.h>
-#include <sys/utsname.h>
-#include <pwd.h>
-#include <grp.h>
-
 #include <wicked/address.h>
 #include <wicked/util.h>
 #include <wicked/logging.h>
@@ -67,11 +53,13 @@
 #include <wicked/tuntap.h>
 #include <wicked/tunneling.h>
 #include <wicked/ethtool.h>
-
 #include <wicked/objectmodel.h>
 #include <wicked/dbus.h>
+#include <wicked/array.h>
+
 #include "appconfig.h"
 #include "util_priv.h"
+#include "array_priv.h"
 #include "duid.h"
 #include "dhcp.h"
 #include "dhcp6/options.h"
@@ -79,15 +67,63 @@
 #include "client/suse/ifsysctl.h"
 #include "client/wicked-client.h"
 
+#include <ctype.h>
+#include <errno.h>
+#include <linux/if_arp.h>
+#include <linux/if_addr.h>
+#include <netlink/netlink.h>
+#include <sys/utsname.h>
+#include <pwd.h>
+#include <grp.h>
+
+
+typedef struct ni_suse_ifcfg {
+	ni_sysconfig_t *		config;
+	ni_compat_netdev_t *		compat;
+	ni_bool_t			broken;
+	ni_bool_t			l2only;
+} ni_suse_ifcfg_t;
+
+#define NI_SUSE_IFCFG_ARRAY_INIT	NI_ARRAY_INIT
+#define NI_SUSE_IFCFG_ARRAY_CHUNK	8
+ni_declare_ptr_array_type(ni_suse_ifcfg);
+
+static ni_suse_ifcfg_t *		ni_suse_ifcfg_new(void);
+static void				ni_suse_ifcfg_free(ni_suse_ifcfg_t *);
+static ni_suse_ifcfg_t *		ni_suse_ifcfg_new_missing(ni_suse_ifcfg_t *,
+							const char *);
+static void				ni_suse_ifcfg_set_hotplug(ni_suse_ifcfg_t *);
+static void				ni_suse_ifcfg_set_l2_only(ni_suse_ifcfg_t *, ni_bool_t);
+static ni_suse_ifcfg_t *		ni_suse_ifcfg_add_l2_port(ni_suse_ifcfg_array_t *,
+							ni_suse_ifcfg_t *, const char *,
+							const char *, const char *,
+							ni_bool_t);
+static ni_suse_ifcfg_t *		ni_suse_ifcfg_add_lower(ni_suse_ifcfg_array_t *,
+							ni_suse_ifcfg_t *, const char *,
+							const char *);
+
+static ni_suse_ifcfg_t *		ni_suse_ifcfg_find_by_ifname(ni_suse_ifcfg_array_t *,
+							const char *);
+
+typedef ni_bool_t (*ifcfg_process_fn_t)(ni_suse_ifcfg_array_t *, ni_suse_ifcfg_t *,
+					const char *, const char *, const char *);
+
+static unsigned int			ni_suse_ifcfg_process_indexed(ni_suse_ifcfg_array_t *,
+							ni_suse_ifcfg_t *, const char *,
+							ifcfg_process_fn_t);
+
+static ni_bool_t			ni_suse_ifcfg_parse(ni_suse_ifcfg_array_t *);
+
+static					ni_declare_ptr_array_init(ni_suse_ifcfg);
+static					ni_declare_ptr_array_destroy(ni_suse_ifcfg);
+static					ni_declare_ptr_array_append(ni_suse_ifcfg);
+
+
 typedef ni_bool_t (*try_function_t)(const ni_sysconfig_t *, ni_netdev_t *, const char *);
 
-static ni_compat_netdev_t *	__ni_suse_read_interface(const char *, const char *);
 static ni_bool_t		__ni_suse_read_globals(const char *, const char *, const char *);
 static void			__ni_suse_free_globals(void);
 static void			__ni_suse_show_unapplied_routes(void);
-static void			__ni_suse_adjust_slaves(ni_compat_netdev_array_t *);
-static void			__ni_suse_adjust_ovs_system(ni_compat_netdev_t *);
-static ni_bool_t		__ni_suse_sysconfig_read(ni_sysconfig_t *, ni_compat_netdev_t *);
 static int			__process_indexed_variables(const ni_sysconfig_t *, ni_netdev_t *,
 							const char *, try_function_t);
 static ni_var_t *		__find_indexed_variable(const ni_sysconfig_t *, const char *, const char *);
@@ -147,7 +183,7 @@ static ni_bool_t		__ni_ipv6_disbled;
 #define __NI_WIRELESS_WPA_PSK_MIN_LEN	8
 
 static ni_bool_t
-__ni_suse_ifcfg_valid_suffix(const char *name, size_t pfxlen)
+ni_suse_ifcfg_valid_suffix(const char *name, size_t pfxlen)
 {
 	const char *blacklist[] = {
 		"~", ".old", ".bak", ".orig", ".scpmbackup",
@@ -173,51 +209,118 @@ __ni_suse_ifcfg_valid_suffix(const char *name, size_t pfxlen)
 }
 
 static ni_bool_t
-__ni_suse_ifcfg_valid_prefix(const char *basename, const char *prefix)
+ni_suse_ifcfg_valid_prefix(const char *basename, const char *prefix)
 {
-	size_t pfxlen;
-
 	if (!basename || !prefix)
 		return FALSE;
 
-	pfxlen = strlen(prefix);
-	if (strncmp(basename, prefix, pfxlen))
-		return FALSE;
+	return ni_string_startswith(basename, prefix);
+}
 
-	return TRUE;
+/*
+ * Read a single ifcfg file and init compat netdev
+ */
+static ni_suse_ifcfg_t *
+ni_suse_ifcfg_read_file(const char *filename)
+{
+	const char *basename = ni_basename(filename);
+	size_t pfxlen = sizeof(__NI_SUSE_CONFIG_IFPREFIX)-1;
+	ni_suse_ifcfg_t *ifcfg = NULL;
+	const char *ifname;
+
+	/* Check in case ni_suse_ifcfg_read_file is used directly */
+	if (!ni_suse_ifcfg_valid_prefix(basename, __NI_SUSE_CONFIG_IFPREFIX)) {
+		ni_error("Rejecting file without '%s' prefix: %s",
+				__NI_SUSE_CONFIG_IFPREFIX, filename);
+		return NULL;
+	}
+	if (!ni_suse_ifcfg_valid_suffix(basename, pfxlen)) {
+		ni_error("Rejecting blacklisted %sfile suffix: %s",
+				__NI_SUSE_CONFIG_IFPREFIX, filename);
+		return NULL;
+	}
+
+	ifname = basename + pfxlen;
+	if (!ni_netdev_name_is_valid(ifname)) {
+		ni_error("Rejecting suspect interface name: %s", ifname);
+		return NULL;
+	}
+
+	if (!(ifcfg = ni_suse_ifcfg_new())) {
+		ni_error("Unable to allocate ifcfg structure for %sfile: %s",
+				__NI_SUSE_CONFIG_IFPREFIX, filename);
+		return NULL;
+	}
+
+	if (!(ifcfg->compat = ni_compat_netdev_new(ifname))) {
+		ni_error("Unable to allocate netdev structure for %sfile: %s",
+				__NI_SUSE_CONFIG_IFPREFIX, filename);
+		ni_suse_ifcfg_free(ifcfg);
+		return NULL;
+	}
+
+	if (!(ifcfg->config = ni_sysconfig_read(filename))) {
+		/* errors reported */
+		ni_suse_ifcfg_free(ifcfg);
+		return NULL;
+	}
+
+	return ifcfg;
 }
 
+/*
+ * Read ifcfg files in directory and init compat netdevs
+ */
 static int
-__ni_suse_ifcfg_scan_files(const char *dirname, ni_string_array_t *res)
+ni_suse_ifcfg_read_files(ni_suse_ifcfg_array_t *ifcfgs, const char *dirname)
 {
 	ni_string_array_t files = NI_STRING_ARRAY_INIT;
 	const char *pattern = __NI_SUSE_CONFIG_IFPREFIX"*";
 	size_t pfxlen = sizeof(__NI_SUSE_CONFIG_IFPREFIX)-1;
-	unsigned int i, count = res->count;
+	unsigned int i, count = ifcfgs->count;
+	ni_suse_ifcfg_t *ifcfg;
+	char *filename = NULL;
+	const char *file;
 
-	if( !ni_scandir(dirname, pattern, &files))
+	if (!ni_scandir(dirname, pattern, &files))
 		return 0;
 
-	for(i = 0; i < files.count; ++i) {
-		const char *file = files.data[i];
+	for (i = 0; i < files.count; ++i) {
+		if (!(file = files.data[i]))
+			continue;
+
+		if (!ni_suse_ifcfg_valid_suffix(file, pfxlen)) {
+			/* e.g. .bak suffix created by firewalld */
+			ni_debug_readwrite("Ignoring blacklisted %sfile suffix: %s",
+					__NI_SUSE_CONFIG_IFPREFIX, file);
+			continue;
+		}
 
-		if (!__ni_suse_ifcfg_valid_suffix(file, pfxlen)) {
-			ni_debug_readwrite("Ignoring blacklisted %sfile: %s",
+		if (!ni_string_printf(&filename, "%s/%s", dirname, file)) {
+			ni_error("Failed to construct full path for %sfile %s: %m",
 					__NI_SUSE_CONFIG_IFPREFIX, file);
 			continue;
 		}
 
-		ni_string_array_append(res, file);
+		if (!(ifcfg = ni_suse_ifcfg_read_file(filename)))
+			continue;	/* errors reported */
+
+		if (!ni_suse_ifcfg_array_append(ifcfgs, ifcfg)) {
+			ni_error("Failed to add '%s' structure to array: %m", file);
+			ni_suse_ifcfg_free(ifcfg);
+		}
 	}
+
+	ni_string_free(&filename);
 	ni_string_array_destroy(&files);
 
-	return res->count - count;
+	return ifcfgs->count - count;
 }
 
 ni_bool_t
 __ni_suse_get_ifconfig(const char *root, const char *path, ni_compat_ifconfig_t *result)
 {
-	ni_string_array_t files = NI_STRING_ARRAY_INIT;
+	ni_suse_ifcfg_array_t ifcfgs = NI_SUSE_IFCFG_ARRAY_INIT;
 	ni_bool_t success = FALSE;
 	char pathbuf[PATH_MAX];
 	char *pathname = NULL;
@@ -242,28 +345,16 @@ __ni_suse_get_ifconfig(const char *root, const char *path, ni_compat_ifconfig_t
 		}
 	} else
 	if (ni_isdir(pathname)) {
+
 		if (!__ni_suse_read_globals(root, _path, pathname))
 			goto done;
 
-		if (!__ni_suse_ifcfg_scan_files(pathname, &files)) {
+		if (!ni_suse_ifcfg_read_files(&ifcfgs, pathname)) {
 			ni_debug_readwrite("No ifcfg files found in %s", pathname);
 			success = TRUE;
 			goto done;
 		}
 
-		for (i = 0; i < files.count; ++i) {
-			const char *filename = files.data[i];
-			const char *ifname = filename + (sizeof(__NI_SUSE_CONFIG_IFPREFIX)-1);
-			ni_compat_netdev_t *compat;
-
-			snprintf(pathbuf, sizeof(pathbuf), "%s/%s", pathname, filename);
-			if (!(compat = __ni_suse_read_interface(pathbuf, ifname)))
-				continue;
-
-			ni_compat_netdev_set_origin(compat, result->schema, pathbuf);
-			ni_compat_netdev_array_append(&result->netdevs, compat);
-		}
-
 		if (__ni_suse_config_defaults) {
 			extern unsigned int ni_wait_for_interfaces;
 
@@ -271,13 +362,28 @@ __ni_suse_get_ifconfig(const char *root, const char *path, ni_compat_ifconfig_t
 						"WAIT_FOR_INTERFACES",
 						&ni_wait_for_interfaces);
 		}
+
+		ni_suse_ifcfg_parse(&ifcfgs);
 	} else {
 		ni_error("Cannot use '%s' to read suse ifcfg files -- not a directory",
 				pathname);
 		goto done;
 	}
 
-	__ni_suse_adjust_slaves(&result->netdevs);
+	for (i = 0; i < ifcfgs.count; ++i) {
+		ni_suse_ifcfg_t *ifcfg = ifcfgs.data[i];
+
+		if (ifcfg->broken)
+			continue;
+
+		ni_compat_netdev_set_origin(ifcfg->compat, result->schema,
+						ifcfg->config->pathname);
+		ni_compat_netdev_array_append(&result->netdevs, ifcfg->compat);
+		ifcfg->compat = NULL;
+		ni_sysconfig_free(ifcfg->config);
+		ifcfg->config = NULL;
+	}
+
 	__ni_suse_show_unapplied_routes();
 
 	success = TRUE;
@@ -285,7 +391,7 @@ __ni_suse_get_ifconfig(const char *root, const char *path, ni_compat_ifconfig_t
 done:
 	ni_string_free(&pathname);
 	__ni_suse_free_globals();
-	ni_string_array_destroy(&files);
+	ni_suse_ifcfg_array_destroy(&ifcfgs);
 	return success;
 }
 
@@ -495,12 +601,12 @@ __ni_suse_free_globals(void)
 	ni_string_free(&__ni_suse_default_hostname);
 
 	if (__ni_suse_config_defaults) {
-		ni_sysconfig_destroy(__ni_suse_config_defaults);
+		ni_sysconfig_free(__ni_suse_config_defaults);
 		__ni_suse_config_defaults = NULL;
 	}
 
 	if (__ni_suse_dhcp_defaults) {
-		ni_sysconfig_destroy(__ni_suse_dhcp_defaults);
+		ni_sysconfig_free(__ni_suse_dhcp_defaults);
 		__ni_suse_dhcp_defaults = NULL;
 	}
 
@@ -1559,65 +1665,16 @@ error:
 	return FALSE;
 }
 
-
-/*
- * Read the configuration of a single interface from a sysconfig file
- */
-static ni_compat_netdev_t *
-__ni_suse_read_interface(const char *filename, const char *ifname)
-{
-	const char *basename = ni_basename(filename);
-	size_t pfxlen = sizeof(__NI_SUSE_CONFIG_IFPREFIX)-1;
-	ni_compat_netdev_t *compat = NULL;
-	ni_sysconfig_t *sc;
-
-	if (ni_string_len(ifname) == 0) {
-		if (!__ni_suse_ifcfg_valid_prefix(basename, __NI_SUSE_CONFIG_IFPREFIX)) {
-			ni_error("Rejecting file without '%s' prefix: %s",
-				__NI_SUSE_CONFIG_IFPREFIX, filename);
-			return NULL;
-		}
-		if (!__ni_suse_ifcfg_valid_suffix(basename, pfxlen)) {
-			ni_error("Rejecting blacklisted %sfile: %s",
-				__NI_SUSE_CONFIG_IFPREFIX, filename);
-			return NULL;
-		}
-		ifname = basename + pfxlen;
-	}
-
-	if (!ni_netdev_name_is_valid(ifname)) {
-		ni_error("Rejecting suspect interface name: %s", ifname);
-		return NULL;
-	}
-
-	if (!(sc = ni_sysconfig_read(filename)))
-		goto error;
-
-	compat = ni_compat_netdev_new(ifname);
-	if (!compat || !__ni_suse_sysconfig_read(sc, compat))
-		goto error;
-
-	ni_sysconfig_destroy(sc);
-	return compat;
-
-error:
-	if (sc)
-		ni_sysconfig_destroy(sc);
-	if (compat)
-		ni_compat_netdev_free(compat);
-	return NULL;
-}
-
 /*
  * Translate the SUSE startmodes to <control> element
  */
 static ni_ifworker_control_t *
-__ni_suse_startmode(const ni_sysconfig_t *sc)
+ni_suse_ifcfg_parse_startmode(const ni_sysconfig_t *sc)
 {
-	static const struct __ni_control_params {
+	static const struct ni_suse_control_params {
 		const char *		name;
 		ni_ifworker_control_t	control;
-	} __ni_suse_control_params[] = {
+	} control_params[] = {
 		/* manual is the default in ifcfg */
 		{ "manual",	{ "manual",	NULL,		FALSE,	FALSE,	NI_TRISTATE_DEFAULT,	0, 0 } },
 
@@ -1635,18 +1692,22 @@ __ni_suse_startmode(const ni_sysconfig_t *sc)
 
 		{ NULL }
 	};
-	const struct __ni_control_params *p, *params = NULL;
+	const struct ni_suse_control_params *p, *params = NULL;
 	ni_ifworker_control_t *control;
 	const char *mode, *value;
 
-	params = &__ni_suse_control_params[0];
-	if (sc && (mode = ni_sysconfig_get_value(sc, "STARTMODE"))) {
-		for (p = __ni_suse_control_params; p->name; ++p) {
+	params = &control_params[0];
+	if ((mode = ni_sysconfig_get_value(sc, "STARTMODE"))) {
+		for (p = control_params; p->name; ++p) {
 			if (ni_string_eq(p->name, mode)) {
 				params = p;
 				break;
 			}
 		}
+		if (!p->name) {
+			ni_warn("%s: ifcfg file with invalid STARTMODE='%s', assuming '%s'",
+					ni_basename(sc->pathname), mode, params->name);
+		}
 	}
 
 	if ((control = ni_ifworker_control_clone(&params->control))) {
@@ -1683,9 +1744,9 @@ __ni_suse_startmode(const ni_sysconfig_t *sc)
  * Try loopback interface
  */
 static int
-try_loopback(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_loopback(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 
 	/* Consider "lo" as a reserved name for loopback. */
 	if (strcmp(dev->name, "lo"))
@@ -1715,9 +1776,10 @@ __maybe_infiniband(const char *ifname)
 }
 
 static int
-try_infiniband(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_infiniband(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	const char *umcast;
 	const char *mode;
 	const char *pkey;
@@ -2210,25 +2272,27 @@ try_add_ethtool_vars(const ni_sysconfig_t *sc, ni_netdev_t *dev, const char *suf
 	return TRUE;
 }
 
-static int
-ni_suse_ifcfg_get_ethtool(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+static ni_bool_t
+ni_suse_ifcfg_parse_ethtool(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_compat_netdev_t *compat = ifcfg->compat;
 	ni_netdev_t *dev = compat->dev;
 
 	/* process ETHTOOL_OPTIONS[SUFFIX] array */
 	if (__process_indexed_variables(sc, dev, "ETHTOOL_OPTIONS",
 					try_add_ethtool_vars) < 0) {
-		ni_error("ifcfg-%s: Cannot parse ETHTOOL_OPTIONS variables",
+		ni_warn("ifcfg-%s: Cannot parse ETHTOOL_OPTIONS variables",
 				dev->name);
-		return -1;
 	}
-	return 0;
+	return TRUE;
 }
 
 static int
-try_ethernet(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_ethernet(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	const char *lladdr = NULL;
 
 	if (dev->link.type != NI_IFTYPE_UNKNOWN)
@@ -2257,26 +2321,27 @@ try_ethernet(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
  * Global bonding configuration is contained in BONDING_MODULE_OPTS
  */
 static ni_bool_t
-try_add_bonding_slave(const ni_sysconfig_t *sc, ni_netdev_t *dev, const char *suffix)
+try_add_bonding_port(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg,
+		const char *port, const char *variable, const char *suffix)
 {
-	ni_bonding_t *bond;
-	ni_var_t *var;
+	ni_suse_ifcfg_t *pcfg;
+	ni_netdev_t *mdev;
+	const char *type;
 
-	var = __find_indexed_variable(sc, "BONDING_SLAVE", suffix);
-	if (!var || ni_string_empty(var->value))
+	mdev = ifcfg->compat->dev;
+	type = ni_linktype_type_to_name(mdev->link.type);
+	if (!(pcfg = ni_suse_ifcfg_add_l2_port(ifcfgs,
+			ifcfg, mdev->name, type, port, FALSE))) {
+		ni_error("ifcfg-%s: failed to add %s port %s='%s'",
+				mdev->name, type, variable, port);
 		return FALSE;
+	}
 
-	dev->link.type = NI_IFTYPE_BOND;
-
-	if ((bond = ni_netdev_get_bonding(dev)) == NULL)
-		return FALSE;
+	ni_netdev_port_config_destroy(&pcfg->compat->port);
+	ni_netdev_port_config_init(&pcfg->compat->port, mdev->link.type);
+	/* no bond port specific config variables implemented yet */
 
-	if (ni_bonding_has_slave(bond, var->value)) {
-		ni_warn("ifcfg-%s: Duplicate slave in BONDING_SLAVE%s=''%s'",
-				dev->name, suffix, var->value);
-		return TRUE; /* warn without to fail */
-	}
-	return ni_bonding_add_slave(bond, var->value) != NULL;
+	return TRUE;
 }
 
 static ni_bool_t
@@ -2318,9 +2383,10 @@ try_set_bonding_options(ni_netdev_t *dev, const char *options)
 }
 
 static int
-try_bonding(ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_bonding(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	const char *module_opts, *err;
 	const char *lladdr;
 	ni_bool_t enabled;
@@ -2337,10 +2403,6 @@ try_bonding(ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 	dev->link.type = NI_IFTYPE_BOND;
 	(void)ni_netdev_get_bonding(dev);
 
-	if (__process_indexed_variables(sc, dev, "BONDING_SLAVE",
-					try_add_bonding_slave) != 0)
-		return -1;
-
 	if ((module_opts = ni_sysconfig_get_value(sc, "BONDING_MODULE_OPTS")) != NULL) {
 		if (!try_set_bonding_options(dev, module_opts))
 			return -1;
@@ -2361,6 +2423,13 @@ try_bonding(ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 		}
 	}
 
+	if (!ni_suse_ifcfg_process_indexed(ifcfgs, ifcfg, "BONDING_SLAVE",
+			try_add_bonding_port)) {
+		ni_error("ifcfg-%s: invalid bonding without BONDING_SLAVEs",
+				dev->name);
+		return -1;
+	}
+
 	return 0;
 }
 
@@ -2558,76 +2627,98 @@ failure:
 }
 
 static ni_bool_t
-try_add_team_port(const ni_sysconfig_t *sc, ni_netdev_t *dev, const char *suffix)
+try_add_team_port_config(ni_team_port_config_t *pconf, const ni_sysconfig_t *sc,
+		const char *suffix, const char *file)
 {
-	ni_team_port_t *port;
-	ni_team_t *team;
+	ni_bool_t ret = TRUE;
 	ni_var_t *var;
 
-	if (!(team = ni_netdev_get_team(dev)))
-		return FALSE;
-
-	var = __find_indexed_variable(sc, "TEAM_PORT_DEVICE", suffix);
-	if (!var || ni_string_empty(var->value)) {
-		ni_error("ifcfg-%s: TEAM_PORT_DEVICE%s cannot be empty",
-			dev->name, suffix);
-		return FALSE;
-	}
-
-	port = ni_team_port_new();
-	ni_netdev_ref_set_ifname(&port->device, var->value);
-
 	if ((var = __find_indexed_variable(sc, "TEAM_PORT_QUEUE_ID", suffix))) {
-		if (ni_parse_uint(var->value, &port->config.queue_id, 10) < 0) {
-			ni_error("ifcfg-%s: Cannot parse TEAM_PORT_QUEUE_ID%s='%s'",
-				dev->name, suffix, var->value);
-			ni_team_port_free(port);
-			return FALSE;
+		if (ni_parse_uint(var->value, &pconf->queue_id, 10) < 0) {
+			ni_warn("ifcfg-%s: Cannot parse TEAM_PORT_QUEUE_ID%s='%s'",
+				file, suffix, var->value);
+			ret = FALSE;
 		}
 	}
 
 	if ((var = __find_indexed_variable(sc, "TEAM_PORT_PRIO", suffix))) {
-		if (ni_parse_uint(var->value, &port->config.ab.prio, 10) < 0) {
-			ni_error("ifcfg-%s: Cannot parse TEAM_PORT_PRIO%s='%s'",
-				dev->name, suffix, var->value);
-			ni_team_port_free(port);
-			return FALSE;
+		if (ni_parse_uint(var->value, &pconf->ab.prio, 10) < 0) {
+			ni_warn("ifcfg-%s: Cannot parse TEAM_PORT_PRIO%s='%s'",
+				file, suffix, var->value);
+			ret = FALSE;
 		}
 	}
+
 	if ((var = __find_indexed_variable(sc, "TEAM_PORT_STICKY", suffix))) {
-		if (ni_parse_boolean(var->value, &port->config.ab.sticky) < 0) {
-			ni_error("ifcfg-%s: Cannot parse TEAM_PORT_STICKY%s='%s'",
-				dev->name, suffix, var->value);
-			ni_team_port_free(port);
-			return FALSE;
+		if (ni_parse_boolean(var->value, &pconf->ab.sticky) < 0) {
+			ni_warn("ifcfg-%s: Cannot parse TEAM_PORT_STICKY%s='%s'",
+				file, suffix, var->value);
+			ret = FALSE;
 		}
 	}
 
 	if ((var = __find_indexed_variable(sc, "TEAM_PORT_LACP_PRIO", suffix))) {
-		if (ni_parse_uint(var->value, &port->config.lacp.prio, 10) < 0) {
-			ni_error("ifcfg-%s: Cannot parse TEAM_PORT_LACP_PRIO%s='%s'",
-				dev->name, suffix, var->value);
-			ni_team_port_free(port);
-			return FALSE;
+		if (ni_parse_uint(var->value, &pconf->lacp.prio, 10) < 0) {
+			ni_warn("ifcfg-%s: Cannot parse TEAM_PORT_LACP_PRIO%s='%s'",
+				file, suffix, var->value);
+			ret = FALSE;
 		}
 	}
 
 	if ((var = __find_indexed_variable(sc, "TEAM_PORT_LACP_KEY", suffix))) {
-		if (ni_parse_uint(var->value, &port->config.lacp.key, 10) < 0) {
-			ni_error("ifcfg-%s: Cannot parse TEAM_PORT_LACP_KEY%s='%s'",
-				dev->name, suffix, var->value);
-			ni_team_port_free(port);
-			return FALSE;
+		if (ni_parse_uint(var->value, &pconf->lacp.key, 10) < 0) {
+			ni_warn("ifcfg-%s: Cannot parse TEAM_PORT_LACP_KEY%s='%s'",
+				file, suffix, var->value);
+			ret = FALSE;
+		}
+	}
+
+	return ret;
+}
+
+static ni_bool_t
+try_add_team_port(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg,
+		const char *port, const char *variable, const char *suffix)
+{
+	ni_suse_ifcfg_t *pcfg;
+	ni_netdev_t *mdev;
+	ni_team_t *team;
+	ni_bool_t l2v6 = FALSE;
+	const char *type;
+
+	mdev = ifcfg->compat->dev;
+	if ((team = ni_netdev_get_team(mdev))) {
+		ni_team_link_watch_t *lw;
+		unsigned int i;
+
+		for (i = 0; i < team->link_watch.count; i++) {
+			lw = team->link_watch.data[i];
+			if (lw->type == NI_TEAM_LINK_WATCH_NSNA_PING)
+				l2v6 = TRUE;
 		}
 	}
+	type = ni_linktype_type_to_name(mdev->link.type);
+	if (!(pcfg = ni_suse_ifcfg_add_l2_port(ifcfgs,
+			ifcfg, mdev->name, type, port, l2v6))) {
+		ni_error("ifcfg-%s: failed to add %s port %s='%s'",
+				mdev->name, type, variable, port);
+		return FALSE;
+	}
 
-	return ni_team_port_array_append(&team->ports, port);
+	ni_netdev_port_config_destroy(&pcfg->compat->port);
+	if (ni_netdev_port_config_init(&pcfg->compat->port, NI_IFTYPE_TEAM)) {
+		try_add_team_port_config(pcfg->compat->port.team,
+				ifcfg->config, suffix, mdev->name);
+	}
+
+	return TRUE;
 }
 
 static int
-try_team(ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_team(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	const char *value;
 	ni_team_runner_type_t type;
 	ni_team_t *team;
@@ -2866,10 +2957,6 @@ try_team(ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 					try_add_team_link_watch) < 0)
 		return -1;
 
-	if (__process_indexed_variables(sc, dev, "TEAM_PORT_DEVICE",
-					try_add_team_port) < 0)
-		return -1;
-
 #if 0
 	if ((err = ni_team_validate(ni_netdev_get_team(dev))) != NULL) {
 		ni_error("ifcfg-%s: team validation: %s",
@@ -2878,41 +2965,55 @@ try_team(ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 	}
 #endif
 
+	if (!ni_suse_ifcfg_process_indexed(ifcfgs, ifcfg, "TEAM_PORT_DEVICE",
+			try_add_team_port)) {
+		ni_error("ifcfg-%s: invalid bonding without TEAM_PORT_DEVICEs",
+				dev->name);
+		return -1;
+	}
+
 	return 0;
 }
 
 static ni_bool_t
-try_add_ovs_bridge_port(const ni_sysconfig_t *sc, ni_netdev_t *dev, const char *suffix)
+try_add_ovs_bridge_port(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg,
+		const char *port, const char *variable, const char *suffix)
 {
-	const ni_var_t *var;
+	static const char *ovs_system = NULL;
+	ni_suse_ifcfg_t *pcfg;
+	ni_netdev_t *bdev;
+	const char *type;
 
-	if (!dev->ovsbr)
-		return FALSE;
+	if (!ovs_system)
+		ovs_system = ni_linktype_type_to_name(NI_IFTYPE_OVS_SYSTEM);
 
-	var = __find_indexed_variable(sc, "OVS_BRIDGE_PORT_DEVICE", suffix);
-	if (!var || !ni_netdev_name_is_valid(var->value)) {
-		size_t len;
-		if (var && (len = ni_string_len(var->value))) {
-			ni_error("ifcfg-%s: Suspect device in OVS_BRIDGE_PORT_DEVICE%s='%s'",
-					dev->name, suffix, ni_print_suspect(var->value, len));
-		} else {
-			ni_error("ifcfg-%s: OVS_BRIDGE_PORT_DEVICE%s cannot be empty",
-					dev->name, suffix);
-		}
+	bdev = ifcfg->compat->dev;
+	if (ni_string_eq(ovs_system, port)) {
+		ni_error("ifcfg-%s: reserved ovs datapath in %s='%s'",
+				bdev->name, variable, port);
 		return FALSE;
 	}
 
-	if (!ni_ovs_bridge_port_array_add_new(&dev->ovsbr->ports, var->value)) {
-		ni_warn("ifcfg-%s: Cannot add OVS_BRIDGE_PORT_DEVICE%s='%s' or not unique, skipped",
-				dev->name, suffix, var->value);
+	type = ni_linktype_type_to_name(bdev->link.type);
+	if (!(pcfg = ni_suse_ifcfg_add_l2_port(ifcfgs,
+			ifcfg, bdev->name, type, port, FALSE))) {
+		ni_error("ifcfg-%s: failed to add %s port %s='%s'",
+				bdev->name, type, variable, port);
+		return FALSE;
 	}
+
+	ni_netdev_port_config_destroy(&pcfg->compat->port);
+	ni_netdev_port_config_init(&pcfg->compat->port, bdev->link.type);
+	/* no ovs bridge port specific config variables (any more) */
+
 	return TRUE;
 }
 
 static int
-try_ovs_bridge(ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_ovs_bridge(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	ni_ovs_bridge_t *ovsbr;
 	ni_bool_t enabled;
 	const char *parent;
@@ -2929,14 +3030,25 @@ try_ovs_bridge(ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 	}
 
 	dev->link.type = NI_IFTYPE_OVS_BRIDGE;
-	ovsbr = ni_netdev_get_ovs_bridge(dev);
+	if (!(ovsbr = ni_netdev_get_ovs_bridge(dev))) {
+		ni_error("ifcfg-%s: unable to allocate ovs bridge structure",
+				dev->name);
+		return -1;
+	}
 
 	if ((parent = ni_sysconfig_get_value(sc, "OVS_BRIDGE_VLAN_PARENT"))) {
 		if (!ni_netdev_name_is_valid(parent)) {
 			ni_error("ifcfg-%s: Suspect device in OVS_BRIDGE_VLAN_PARENT='%s'",
-					dev->name, ni_print_suspect(parent, ni_string_len(parent)));
+					dev->name,
+					ni_print_suspect(parent, ni_string_len(parent)));
+			return -1;
+		}
+		if (!ni_suse_ifcfg_find_by_ifname(ifcfgs, parent)) {
+			ni_error("ifcfg-%s: Unable to find OVS vlan bridge parent config '%s'",
+					dev->name, parent);
 			return -1;
 		}
+
 		if (!(vlan = ni_sysconfig_get_value(sc, "OVS_BRIDGE_VLAN_TAG"))) {
 			ni_error("ifcfg-%s: OVS_BRIDGE_VLAN_TAG=... missed", dev->name);
 			return -1;
@@ -2951,39 +3063,47 @@ try_ovs_bridge(ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 					dev->name, ovsbr->config.vlan.tag, __NI_VLAN_TAG_MAX);
 			return -1;
 		}
+
 		ni_netdev_ref_set_ifname(&ovsbr->config.vlan.parent, parent);
 		ovsbr->config.vlan.tag = tag;
 	}
 
-	if (__process_indexed_variables(sc, dev, "OVS_BRIDGE_PORT_DEVICE",
-					try_add_ovs_bridge_port) < 0)
-		return -1;
+	ni_suse_ifcfg_process_indexed(ifcfgs, ifcfg, "OVS_BRIDGE_PORT_DEVICE",
+			try_add_ovs_bridge_port);
 
 	return 0;
 }
 
 static int
-try_ovs_system(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_ovs_system(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	static const char *ovs_system = NULL;
-	ni_netdev_t *dev = compat->dev;
 
-	/* Consider ovs-system as a fixed/reserved master device for openvswitch */
+	/* Consider ovs-system as a fixed/reserved datapath name for openvswitch */
 	if (ovs_system == NULL)
 		ovs_system = ni_linktype_type_to_name(NI_IFTYPE_OVS_SYSTEM);
 
-	if (strcmp(dev->name, ovs_system))
+	if (!ni_string_eq(dev->name, ovs_system))
 		return 1;
 
-	if (dev->link.type != NI_IFTYPE_UNKNOWN) {
+	switch (dev->link.type) {
+	case NI_IFTYPE_UNKNOWN:
+		dev->link.type = NI_IFTYPE_OVS_SYSTEM;
+		/*
+		 * This datapath device does not need any setup (not even link up),
+		 * but as it is actively used as master device for all ovs ports,
+		 * we have to consider it in order to resolve dependencies...
+		 */
+		ni_suse_ifcfg_set_l2_only(ifcfg, FALSE);
+		return 0;
+	case NI_IFTYPE_OVS_SYSTEM:
+		return 0;
+	default:
 		ni_error("ifcfg-%s: %s config is using reserved %s device name",
 			dev->name, ni_linktype_type_to_name(dev->link.type), ovs_system);
 		return -1;
 	}
-
-	dev->link.type = NI_IFTYPE_OVS_SYSTEM;
-	__ni_suse_adjust_ovs_system(compat);
-
 	return 0;
 }
 
@@ -2991,10 +3111,101 @@ try_ovs_system(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 /*
  * Bridge devices are recognized by BRIDGE=yes
  */
+static ni_bool_t
+try_add_bridge_port_config(ni_bridge_port_config_t *pconf, const char *file,
+		const char *port, const char *prio, const char *cost)
+{
+	unsigned int tmp;
+	const char *err;
+
+	if (ni_string_empty(prio) || ni_string_eq(prio, "-")) {
+		pconf->priority = NI_BRIDGE_VALUE_NOT_SET;
+	} else if (ni_parse_uint(prio, &tmp, 0) < 0) {
+		ni_warn("ifcfg-%s: unable to parse priority '%s' for port '%s'",
+				file, prio, port);
+	} else if ((err = ni_bridge_port_priority_validate(tmp))) {
+		ni_warn("ifcfg-%s: %s '%s' for port '%s'",
+				file, err, prio, port);
+	} else {
+		pconf->priority = tmp;
+	}
+
+	if (ni_string_empty(cost) || ni_string_eq(cost, "-")) {
+		pconf->path_cost = NI_BRIDGE_VALUE_NOT_SET;
+	} else if (ni_parse_uint(cost, &tmp, 0) < 0) {
+		ni_warn("ifcfg-%s: unable to parse path-cost '%s' for port '%s'",
+				file, cost, port);
+	} else if ((err = ni_bridge_port_path_cost_validate(tmp))) {
+		ni_warn("ifcfg-%s: %s '%s' for port '%s'",
+				file, err, cost, port);
+	} else {
+		pconf->path_cost = tmp;
+	}
+
+	return TRUE;
+}
+
+static ni_bool_t
+try_add_bridge_port(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg,
+		const char *port, const char *prio, const char *cost)
+{
+	ni_suse_ifcfg_t *pcfg;
+	ni_netdev_t *mdev;
+	const char *type;
+
+	mdev = ifcfg->compat->dev;
+	type = ni_linktype_type_to_name(mdev->link.type);
+	if (!(pcfg = ni_suse_ifcfg_add_l2_port(ifcfgs,
+			ifcfg, mdev->name, type, port, FALSE))) {
+		ni_error("ifcfg-%s: failed to add %s port %s",
+				mdev->name, type, port);
+		return FALSE;
+	}
+
+	ni_netdev_port_config_destroy(&pcfg->compat->port);
+	if (ni_netdev_port_config_init(&pcfg->compat->port, mdev->link.type)) {
+		try_add_bridge_port_config(pcfg->compat->port.bridge,
+				mdev->name, port, prio, cost);
+	}
+
+	return TRUE;
+}
+
+static ni_bool_t
+try_add_bridge_ports(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
+{
+	ni_string_array_t ports = NI_STRING_ARRAY_INIT;
+	ni_string_array_t prios = NI_STRING_ARRAY_INIT;
+	ni_string_array_t costs = NI_STRING_ARRAY_INIT;
+	ni_bool_t ret = TRUE;
+	unsigned int i;
+
+	ni_string_split(&ports, ni_sysconfig_get_value(ifcfg->config,
+				"BRIDGE_PORTS"), " \t", 0);
+	ni_string_split(&prios, ni_sysconfig_get_value(ifcfg->config,
+				"BRIDGE_PORTPRIORITIES"), " \t", 0);
+	ni_string_split(&costs, ni_sysconfig_get_value(ifcfg->config,
+				"BRIDGE_PATHCOSTS"), " \t", 0);
+
+	for (i = 0; i < ports.count; ++i) {
+		if (!try_add_bridge_port(ifcfgs, ifcfg,
+				ni_string_array_at(&ports, i),
+				ni_string_array_at(&prios, i),
+				ni_string_array_at(&costs, i)))
+			ret = FALSE;
+	}
+
+	ni_string_array_destroy(&ports);
+	ni_string_array_destroy(&prios);
+	ni_string_array_destroy(&costs);
+	return ret;
+}
+
 static int
-try_bridge(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_bridge(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	ni_bridge_t *bridge;
 	ni_bool_t enabled;
 	const char *value;
